
;*******************************
;*          Lambo II           *
;*******************************
; By Jeff Frohwein

; Last edit 17-Aug-97

        INCLUDE "hardware.inc"

;Version 1.2 or later of 'hardware.inc' is required.
        rev_Check_hardware_inc 1.5

SpriteRoutine EQU $ff80

        SECTION "Low Ram",BSS

SpriteTable     DS      160
CarX            DB
Distance        DB
WinX            DB

        SECTION "Org $0",HOME
        ret

        SECTION "Org $40",HOME[$40]
        jp      VBlankIntr

        SECTION "Org $48",HOME[$48]
        jp      LCDIntr

; DMA copy sprite data to sprite ram

VBlankFirst:
;        push    af
        ld      a,$c0 ;SpriteTable/256
        ldh     [rDMA],a
        ld      a,$28
VBlnkW: dec     a
        jr      nz,VBlnkW
;        pop     af
        ret
VBlankLast:

        DB      "Date 970817"           ; Date stamping info for
                                        ; reference use only
        SECTION "Org $100",HOME[$100]

;*** Beginning of rom execution point ***

        nop
        jp      begin

        NINTENDO_LOGO                   ; Nintendo graphic logo

;Rom Header Info

;    0123456789ABCDEF
 DB "LAMBO II DEMO",0,0,0     ; Cart name   16bytes
 DB 0,0,0                     ; Not used
 DB CART_ROM                  ; Cart type
 DB CART_ROM_256K             ; ROM Size (in bits)
 DB CART_RAM_NONE             ; RAM Size (in bits)
 DB $7e,$ff                       ; Maker ID
 DB 0                         ; Version     =0
 DB $e2                       ; Complement check (important)
 DW $c40e                     ; Checksum (not important)

        SECTION "Org $200",HOME[$200]

        DB      $00,$00         ;1
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;10
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;20
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;30
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;40
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;50
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;60
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;70
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00         ;80
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00
        DB      $00,$00

        DB      $00,$00         ;90

        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10
        DB      $30,$10

        DB      $30,$00

;        SECTION "Org $400",HOME[$400]
;
;        DB      $00,$00,$00,$00,$00,$00,$00,$00
;        DB      $01,$01,$01,$01,$01,$01,$01,$01
;        DB      $00,$00,$00,$00,$00,$00,$00,$00
;        DB      $01,$01,$01,$01,$01,$01,$01,$01
;        DB      $00,$00,$00,$00,$00,$00,$00,$00
;        DB      $01,$01,$01,$01,$01,$01,$01,$01
;        DB      $00,$00,$00,$00,$00,$00,$00,$00
;        DB      $01,$01,$01,$01,$01,$01,$01,$01
;        DB      $00,$00,$00,$00,$00,$00,$00,$00
;        DB      $01,$01,$01,$01,$01,$01,$01,$01


; Library Includes

        INCLUDE "keypad.asm"
        INCLUDE "memory1.asm"
;        INCLUDE "pan1.asm"
;        INCLUDE "u161632a.asm"
        INCLUDE "export.asm"

;Version 1.2 or later of 'keypad.asm' is required.
        rev_Check_keypad_asm 1.2
;Version 1.0 or later of 'memory1.asm' is required.
        rev_Check_memory1_asm 1.0
;Version 1.7 or later of 'pan1.asm' is required.
;        rev_Check_pan1_asm 1.7
;Version 1.1 or later of 'u161632a.asm' is required.
;        rev_Check_u161632a_asm 1.1

begin:
        di
                  ; The stack initializes to $FFFE

        ld      a,0
        ldh     [rIE],a         ;disable interrupts
        ldh     [rIF],a

; Must be in VBL before turning the screen off.
WaitVBL:
        ldh    a,[rLY]         ; $ff44=LCDC Y-Pos
        cp     $90             ; $90 and bigger = in VBL
        jr     c,WaitVBL       ; Loop until it is $90 or >

        ld     a,%00010001
        ldh    [rLCDC],a        ; Turn screen off for memory copy

; Copy Sprite handler to high ram

        ld      hl,VBlankFirst
        ld      de,SpriteRoutine
        ld      b,VBlankLast-VBlankFirst
loadh:  ld      a,[hl+]
        ld      [de],a
        inc     de
        dec     b
        jr      nz,loadh

; Clear sprite table

        ld      hl,SpriteTable
        ld      a,4*40
koopa:  ld      [hl],0
        inc     hl
        dec     a
        jr      nz,koopa

CAR_POS_X EQU     72
CAR_POS_Y EQU     140

        ld      a,CAR_POS_Y
        ld      [SpriteTable+0],a
        ld      a,CAR_POS_X
        ld      [SpriteTable+1],a
        ld      a,64  ;spr number
        ld      [SpriteTable+2],a
        ld      a,$0
        ld      [SpriteTable+3],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+4],a
        ld      a,CAR_POS_X+8
        ld      [SpriteTable+5],a
        ld      a,66  ;spr number
        ld      [SpriteTable+6],a
        ld      a,$0
        ld      [SpriteTable+7],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+8],a
        ld      a,CAR_POS_X+16
        ld      [SpriteTable+9],a
        ld      a,66  ;spr number
        ld      [SpriteTable+10],a
        ld      a,$20
        ld      [SpriteTable+11],a

        ld      a,CAR_POS_Y
        ld      [SpriteTable+12],a
        ld      a,CAR_POS_X+24
        ld      [SpriteTable+13],a
        ld      a,64  ;spr number
        ld      [SpriteTable+14],a
        ld      a,$20
        ld      [SpriteTable+15],a

        ld      a,$e4
        ldh     [rBGP],a         ; Setup default background colors

        ld      hl,TileData+1
        ld      de,$8000
        ld      bc,$1000
        call    mem_Copy         ; Copy tile set to memory

        ld      hl,MapData+4
        ld      de,$9800
        ld      bc,$0400
        call    mem_Copy

;        ld      hl,MapData
;        xor     a
;        call    pan_Init         ; Initialize map

;        ld      de,96
;        ld      hl,300
;        call    pan_Absolute     ; Pan to section of map with Mario

        ld      a,0
        ldh     [rSCX],a
        ld      a,0
        ldh     [rSCY],a

        ld      a,7
        ldh     [rWX],a
        ld      a,144
        ldh     [rWY],a

        ld      a,$e0
        ld      [$ff48],a       ; setup sprite palette 0 colors
        ld      [$ff49],a       ; setup sprite palette 1 colors

;        ld      a,1
;        ld      [$9800],a
;        ld      [$9800+$20],a
;        ld      [$9800+$40],a
;        ld      [$9800+$60],a
;        ld      [$9800+$80],a
;        ld      [$9800+$a0],a
;        ld      [$9800+$c0],a
;        ld      [$9800+$e0],a

; Interrupt Initialize

        ld      a,0
        ldh     [$ad],a
        ld      a,90
        ldh     [$45],a
        ld      a,2
        ldh     [$8e],a

        ld      a,$00
        ldh     [$8f],a
        ld      a,$4
        ldh     [$90],a

        ld      a,$48
        ldh     [$91],a
        ld      a,$40
        ldh     [$92],a

        xor     a
        ld      [Distance],a

        call    l5770

        ld      a,$40
        ldh     [rSTAT],a

        ld      a,LCDCF_ON|LCDCF_BG8000|LCDCF_BG9800|LCDCF_BGON|LCDCF_OBJ16|LCDCF_OBJON|LCDCF_WINON
;        ld      a,%10010011
        ldh     [rLCDC],a        ; Turn screen on

        ld      a,3
        ldh     [rIE],a          ;enable vblank interrupt

        ei

;        ld      a,256-16
;        call    l1b74
;        call    l1b74

        xor     a
        ld      [CarX],a

; Read keypad and scroll screen if requested.

loop:
        call    pad_Read

        bit     PADB_UP,a
        jr      z,loop2

        ld      a,[Distance]
        dec     a
        and     15
        ld      [Distance],a

        ld      a,[WinX]
        dec     a
        ld      [WinX],a


        jr      loop5
loop2:  bit     PADB_DOWN,a
        jr      z,loop3

        ld      a,[Distance]
        inc     a
        and     15
        ld      [Distance],a

        ld      a,[WinX]
        inc     a
        ld      [WinX],a

        jr      loop5
loop3:  bit     PADB_LEFT,a
        jr      z,loop4

        ld      a,[CarX]
        dec     a
        ld      [CarX],a
        call    l1b74

        jr      loop5
loop4:  bit     PADB_RIGHT,a
        jr      z,loop

        ld      a,[CarX]
        inc     a
        ld      [CarX],a
        call    l1b74

; Delay between scrolls

loop5:  ld      de,$1000
loop6:  dec     de
        ld      a,d
        or      e
        jr      nz,loop6

        jp      loop

; LCDC Interrupt Routine

LCDIntr:
        di
        push    af
        push    de
        push    hl
        ldh     a,[$ad]
        srl     a
        jr      c,l297d

        ldh     a,[$45]
        ld      l,a
        ld      h,0
        inc     a
        cp      144             ; $90
        jr      nz,l2947
        ld      a,90            ; $5a
l2947:  ldh     [$45],a

; Set scroll Y register
        ldh     a,[$8e]
        ld      d,a
        ld      e,h
        add     hl,hl
        add     hl,de
        ld      a,[hl+]
        ld      e,a
        ld      a,[hl]
        ldh     [$42],a

; Set scroll X register
        ldh     a,[$45]
        sub     90-2            ; $58
        ld      l,a
        ld      h,$db
        ld      a,e
        add     a,[hl]
        ldh     [$43],a

        ld      e,l
        ld      d,0
        ldh     a,[$8f]
        ld      l,a
        ldh     a,[$90]
        ld      h,a
        add     hl,de
        bit     0,[hl]
        jr      z,l2975

        ldh     a,[$92]
        ldh     [$47],a
        pop     hl
        pop     de
        pop     af
        reti

l2975:  ldh     a,[$91]
        ldh     [$47],a
        pop     hl
        pop     de
        pop     af
        reti

l297d:  ldh     a,[$45]
        ld      l,a
        inc     a
        cp      $50
        jr      nz,l2987
        ld      a,$40
l2987:  ldh     [$45],a
        ld      a,l
        sub     $40
        ld      l,a
        ld      h,0
        ld      de,l299a
        add     hl,de
        ld      a,[hl]
        ldh     [$42],a
        pop     hl
        pop     de
        pop     af
        reti

l299a:  DB      $ff,$ff,$fe,$fe,$fd,$fd,$fc,$fc
        DB      $fb,$fb,$fa,$fa,$f9,$f9,$f8,$f8

; VBlank Interrupt Routine

VBlankIntr:
        di
        push    af
        push    de
        push    hl

        ld      a,$e4           ;Set Background color
        ldh     [rBGP],a

        ld      a,[WinX]
        ldh     [$43],a
        ld      a,0
        ldh     [$42],a

        call    SpriteRoutine

        ld      a,[Distance]
        add     a,a
        ld      l,a
        ld      h,0
        ld      de,l0003
        add     hl,de
        ld      a,[hl+]
        ldh     [$8f],a
        ld      a,[hl]
        ldh     [$90],a

        pop     hl
        pop     de
        pop     af
        reti

l1b74:
;        ld      a,($c45c)
;        or      a
;        ret     z

        ld      c,a
        bit     7,a
        jr      z,l1b81
        cpl
        add     a,1
l1b81:  add     a,a
        ld      l,a
        ld      h,0
;        ld      a,7
;        call    l2dc3
        ld      de,UserPer
        add     hl,de
        ld      a,[hl+]
        ld      h,[hl]
        ld      l,a
        ld      d,$db
        ld      e,0
        ld      b,$39
l1b97:  ld      a,[hl+]
        bit     7,c
        jr      z,l1b9f
        cpl
        add     a,1
l1b9f:  ld      [de],a
        inc     de
        dec     b
        jr      nz,l1b97
;        ld      a,1
;        call    l2dc3
        ret

l5770:  xor     a
        ld      h,$db
        ld      l,0
        ld      b,$ff
l5777:  ld      [hl+],a
        dec     b
        jr      nz,l5777
        ret

; Clear screen

clsgr:  ld      hl,$8000
        ld      d,0
        ld      e,16            ; x2=4096
clsgr2: xor     a               ; A = 0
        ld      [hl+],a
        dec     d
        jr      nz,clsgr2
        dec     e
        jr      nz,clsgr2
        ret

initscr:
        ld      hl,$9800        ; First clear the screen
        ld      e,4
cloop1: ld      d,0
cloop2: di
;        HV_WAIT
        ld      a,$ff           ; This char (0ffh) isn't used for GFX.
        ld      [hl+],a
        ei

        dec     d
        jr      nz,cloop2
        dec     e
        jr      nz,cloop1
        ld      b,0
        ld      hl,$9822        ; Now draw the 16*15 matrix
        ld      e,$f
loop10: ld      d,$10
loop20: di
;        HV_WAIT
        ld      a,b
        swap    a               ; The screen must be rotated by 90.
        ld      [hl+],a
        ei

        inc     b
        dec     d
        jr      nz,loop20
        push    de
        ld      d,0
        ld      e,$10
        add     hl,de
        pop     de
        dec     e
        jr      nz,loop10

        ret

UserPer:
        INCLUDE "userper.asm"   ;Include user perspective table



l0003:   DW      l1610,l164b,l1686,l16c1,l16fc,l1737,l1772,l17ad
         DW      l17e8,l1823,l185e,l1899,l18d4,l190f,l194a,l1985

l1610:   DB     0,1,1,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0
         DB     0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
         DB     1,1,1,1,1,1
l164b:   DB     0,1,0,1,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0
         DB     0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
         DB     1,1,1,1,1,1
l1686:   DB     0,1,0,1,0,0,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0
         DB     0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
         DB     1,1,1,1,0,0
l16c1:   DB     0,1,0,1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0
         DB     0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
         DB     0,0,0,0,0,0
l16fc:   DB     1,0,1,0,0,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0
         DB     0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0
         DB     0,0,0,0,0,0
l1737:   DB     0,1,0,1,0,0,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1
         DB     1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0
         DB     0,0,0,0,0,0
l1772:   DB     0,1,0,0,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1
         DB     1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         DB     0,0,0,0,0,0
l17ad:   DB     0,1,0,1,0,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1
         DB     1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         DB     0,0,0,0,0,0
l17e8:   DB     0,1,0,0,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1
         DB     1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         DB     0,0,0,0,0,0
l1823:   DB     0,1,0,1,0,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1
         DB     1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         DB     0,0,0,0,0,0
l185e:   DB     0,1,0,1,0,1,1,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1
         DB     1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
         DB     0,0,0,0,0,1
l1899:   DB     0,1,0,1,0,1,1,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1
         DB     1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1
         DB     1,1,1,1,1,1
l18d4:   DB     1,0,1,0,1,1,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1
         DB     1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1
         DB     1,1,1,1,1,1
l190f:   DB     0,1,0,1,0,1,1,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1
         DB     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1
         DB     1,1,1,1,1,1
l194a:   DB     0,1,0,1,1,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0
         DB     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1
         DB     1,1,1,1,1,1
l1985:   DB     0,1,0,1,0,1,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0
         DB     0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
         DB     1,1,1,1,1,1

